#include "stdafx.h"
#include "NeMessenger.h"
#include "InfoAboutMeWnd.h"
#include "main_frame.hpp"

IMPLEMENT_DYNAMIC(CInfoAboutMeWnd, CWnd)

CInfoAboutMeWnd::CInfoAboutMeWnd()
{
	// BG
	m_pImgBG = NULL;
	m_pImgLogo = NULL;

	m_pImgStatusOverBG = NULL;
	m_pImgStatusDraw = NULL;
	m_pImgStatusFrom = NULL;
	m_pImgStatusTo = NULL;
	m_pImgIPTStatus = NULL;
	m_pImgIPTOverBG = NULL;

	m_crEditNickBGOver = DEF_EDIT_NICK_BG_OVER_COLOR;
	m_crEditNickBGClick = DEF_EDIT_NICK_BG_CLICK_COLOR;

	// dimension
	m_rtFrame.SetRectEmpty();
	m_rtLogo.SetRectEmpty();
	m_rtStatus.SetRectEmpty();
	m_rtName.SetRectEmpty();
	m_rtDepartment.SetRectEmpty();
	m_rtNickName.SetRectEmpty();
	m_rtEdit.SetRectEmpty();

	// status
	m_nStatusRotate = 0;
	m_bStatusRotateFlip = FALSE;
	m_rtIPTStatus.SetRectEmpty();

	// edit
	m_crOutline = RGB(0, 128, 0);
	m_bEditNickName = FALSE;

	// attribute
	m_strName = _T("");
	m_strDepartment = _T("");
	m_strNickName = _T("");
	m_strNickNameAbbr = _T("");
	m_strEmptyNickName = _T("");

	m_gtStatus = ustOFFLINE;

	// tracking
	m_bTracking = FALSE;
	m_bHoverStatus = FALSE;
	m_bHoverIPT = FALSE;
	m_bDownStatus = FALSE;	
	m_bHoverNickName = FALSE;
	m_bDownNickName = FALSE;
}

CInfoAboutMeWnd::~CInfoAboutMeWnd()
{
	
}

BEGIN_MESSAGE_MAP(CInfoAboutMeWnd, CWnd)
	ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_MOUSEHOVER()
	ON_WM_MOUSELEAVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_SIZE()
	//ON_MESSAGE(WM_MOUSEHOVER,				OnMouseHover)
	//ON_MESSAGE(WM_MOUSELEAVE,				OnMouseLeave)
	ON_WM_SETCURSOR()
	ON_WM_DESTROY()	
END_MESSAGE_MAP()

int CInfoAboutMeWnd::GetImgBGWidth()
{
	int nImgWidth = 0;
	if (m_pImgBG)
		nImgWidth = m_pImgBG->GetWidth();

	return nImgWidth;
}

int	CInfoAboutMeWnd::GetImgBGHeight()
{
	int nImgHeight = 0;
	if (m_pImgBG)
		nImgHeight = m_pImgBG->GetHeight();

	return nImgHeight;
}

void CInfoAboutMeWnd::SetImgBGPath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);
	m_pImgBG = new Image(strImgPath);
}

void CInfoAboutMeWnd::SetImgLogoPath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);
	m_pImgLogo = new Image(strImgPath);
}

void CInfoAboutMeWnd::SetImgStatusOverBGPath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);
	m_pImgStatusOverBG = new Image(strImgPath);


}

void CInfoAboutMeWnd::SetImgIPTOverBGPath( CString strFileName )
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);
	m_pImgIPTOverBG = new Image(strImgPath);
}


void CInfoAboutMeWnd::SetImgStatusPath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	if (m_pImgStatusTo)
	{
		delete m_pImgStatusTo;
		m_pImgStatusTo = NULL;
	}

	m_pImgStatusTo = new Image(strImgPath);
}
void CInfoAboutMeWnd::SetImgIPTStatusPath( CString strFileName )
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	if (m_pImgIPTStatus)
	{
		delete m_pImgIPTStatus;
		m_pImgIPTStatus = NULL;
	}

	m_pImgIPTStatus = new Image(strImgPath);
	SetIPT();

}


void CInfoAboutMeWnd::SetAboutMeStatus(GTUserStatusType gtStatus)
{
	m_gtStatus = gtStatus;

	if (m_pImgStatusFrom)
	{
		delete m_pImgStatusFrom;
		m_pImgStatusFrom = NULL;
	}

	if (m_pImgStatusTo)
	{
		m_pImgStatusFrom = m_pImgStatusTo;
		m_pImgStatusTo = NULL;
	}

	AllocateStatusImage();

	RotateImageWithInterval(0);

}
void CInfoAboutMeWnd::SetAboutIPTStatus( NTIPTStatusType iptStatus )
{
	m_myIPTStatus = iptStatus;

	if (m_pImgIPTStatus)
	{
		delete m_pImgIPTStatus;
		m_pImgIPTStatus = NULL;
	}

	AllocateIPTStatusImage();

}



BOOL CInfoAboutMeWnd::IsMobileOnline()
{
	if( m_gtStatus & ustMOBILE )
		return true;

	return false;
}

void CInfoAboutMeWnd::SetName(CString strName)
{
	m_strName = strName;

	RedrawWindow(&m_rtName, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}


void CInfoAboutMeWnd::SetIPT()
{
	RedrawWindow(&m_rtIPTStatus, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}


void CInfoAboutMeWnd::SetDepartment(CString strDepartment)
{
	m_strDepartment = strDepartment;

	RedrawWindow(&m_rtDepartment, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CInfoAboutMeWnd::SetEmptyNickNameText(CString strEmptyNickName)
{
	m_strEmptyNickName = strEmptyNickName;
}

void CInfoAboutMeWnd::SetNickName(CString strNickName)
{
	m_strNickName = strNickName;
	m_strNickNameAbbr = m_strNickName;

	if (!m_strNickName.IsEmpty())
	{
		m_strNickNameAbbr = RecalcTextString(this, m_strNickName, g_defaultFontFaceName, DEF_NICKNAME_FONT_SIZE, FontStyleRegular, m_rtNickName);
	}

	CRect rtNickName = m_rtNickName;
	rtNickName.InflateRect(0, 0, 5, 0);
	RedrawWindow(&rtNickName, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CInfoAboutMeWnd::SetEditNickName(BOOL bEdit)
{
	if (NULL == m_editNickName.GetSafeHwnd())
	{
		return;
	}

	m_bEditNickName = bEdit;

	if (m_bEditNickName)
	{
		m_editNickName.SetLimitText(NICKNAME_MAX_LENGTH);
		m_editNickName.ShowWindow(SW_SHOW);
		m_editNickName.SetWindowText(m_strNickName);
		m_editNickName.SetFocus();
		m_editNickName.SetSel(0, -1);
	}
	else
	{
		m_editNickName.ShowWindow(SW_HIDE);
	}

	CRect rtNickName = m_rtNickName;
	rtNickName.InflateRect(4, 4, 4, 4);
	RedrawWindow(&rtNickName, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

// CInfoAboutMeWnd ޽ óԴϴ.
int CInfoAboutMeWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_editNickName.Create(WS_CHILD | ES_AUTOHSCROLL, m_rtNickName, this, ID_EDIT_NICKNAME))
		return -1;
	m_editNickName.SetFont(&g_ftDefault10PT);

	return 0;
}

BOOL CInfoAboutMeWnd::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
}

void CInfoAboutMeWnd::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	PAINTSTRUCT ps = dc.m_ps;
	int psWidth = ps.rcPaint.right - ps.rcPaint.left;
	int psHeight = ps.rcPaint.bottom - ps.rcPaint.top;

	int nPX = ps.rcPaint.left;
	int nPY = ps.rcPaint.top;

	CRect rtPS(nPX, nPY, nPX + psWidth, nPY + psHeight);

	CRect rt(0, 0, 0, 0);
	GetClientRect(&rt);
	//int nWndWidth = rt.Width();
	//int nWndHeight = rt.Height();

	HDC hdc = dc.GetSafeHdc();

	HDC	hdcMemory = CreateCompatibleDC(hdc);

	if (hdcMemory == NULL)
		return;

	HBITMAP hbmpMem = CreateCompatibleBitmap(hdc, psWidth, psHeight);

	HGDIOBJ hbmpOld = ::SelectObject(hdcMemory,  hbmpMem);

	Graphics graph(hdcMemory);

	if (hbmpMem)
	{
		graph.SetSmoothingMode(SmoothingModeAntiAlias);
		graph.SetInterpolationMode(InterpolationModeHighQualityBicubic);
		graph.SetPageUnit(UnitPixel);

		ImageAttributes ImgAttr;

		ImageAttributes ImgAttr2;
		ColorMatrix matrix2 = {	1.05f, 0.00f, 0.00f, 0.00f, 0.00f,
			0.00f, 1.05f, 0.00f, 0.00f, 0.00f,
			0.00f, 0.00f, 1.05f, 0.00f, 0.00f,
			0.00f, 0.00f, 0.00f, 1.00f, 0.00f,
			0.05f, 0.05f, 0.05f, 0.00f, 1.00f };
		ImgAttr2.SetColorMatrix(&matrix2);

		if (m_pImgBG)
			DrawImageToStretchHorz(&graph, m_pImgBG, &rtPS, &m_rtFrame, Color(255, 230, 233, 238), &ImgAttr);
		if (m_pImgLogo)
			DrawImageToDest(&graph, m_pImgLogo, &rtPS, &m_rtLogo, &ImgAttr);

		if (m_bHoverStatus)
		{
			if (m_pImgStatusOverBG)
				DrawImageToDest(&graph, m_pImgStatusOverBG, &rtPS, &m_rtStatus, &ImgAttr);
		}
		if(m_bHoverIPT && GET_APP()->IsAvailableIPT() )
		{
			if (m_pImgIPTOverBG)
			{
				DrawImageToDest(&graph, m_pImgIPTOverBG, &rtPS, &m_rtIPTStatus, &ImgAttr);
			}
		}

		ImageAttributes* pImgAttr = &ImgAttr;
		if (m_bHoverStatus)
			pImgAttr = &ImgAttr2;

		int nSX = 0, nSY = 0;
		if (m_pImgStatusDraw)
		{
			int nWidth = m_pImgStatusDraw->GetWidth();
			int nHeight = m_pImgStatusDraw->GetHeight();

			nSX = m_rtStatus.left - rtPS.left;
			nSY = m_rtStatus.top - rtPS.top;

			Point destPoints[] = { Point(nSX + m_nStatusRotate, nSY), 
								   Point(nSX + nWidth - m_nStatusRotate, nSY), 
								   Point(nSX + m_nStatusRotate, nSY + nHeight) };
			graph.DrawImage(m_pImgStatusDraw, destPoints, 3);
		}
		if (m_pImgIPTStatus  && GET_APP()->IsAvailableIPT() )
		{
			int nWidth = m_pImgIPTStatus->GetWidth();
			int nHeight = m_pImgIPTStatus->GetHeight();
			nSX = m_rtIPTStatus.left + DEF_IPT_STATUS_BG_GAP_X - rtPS.left;
			nSY = m_rtIPTStatus.top + DEF_IPT_STATUS_BG_GAP_Y  - rtPS.top;

			Point destPoints[] = { Point(nSX , nSY), 
				Point(nSX + nWidth , nSY), 
				Point(nSX , nSY + nHeight) };
			graph.DrawImage(m_pImgIPTStatus, destPoints, 3);

		}

		if (m_strName.GetLength() > 0)
		{
			DrawTextToDest2(&graph,
						    m_strName, &rtPS, &m_rtName,
						    g_defaultFontFaceName, DEF_ME_NAME_FONT_SIZE,
						    StringAlignmentNear,
						    FontStyleBold,
						    Color(255, 0, 0, 0));
		}

		if (m_bEditNickName)
		{
			Pen pen(m_crEditNickBGClick, 1);

			int nSX = m_rtNickName.left - rtPS.left;
			int nSY = m_rtNickName.top - rtPS.top;

			graph.DrawRectangle(&pen, nSX - 1, nSY - 1, m_rtNickName.Width() + 2, m_rtNickName.Height() + 2);
		}
		else
		{
			CString strNickName = m_strNickNameAbbr;
			if (strNickName.IsEmpty())
				strNickName = m_strEmptyNickName;
			
			CRect rtNickName = m_rtNickName;
			rtNickName.InflateRect(0, 0, 10, 0);
			DrawTextToDest2(&graph,
							strNickName, &rtPS, &rtNickName,
							g_defaultFontFaceName, DEF_NICKNAME_FONT_SIZE,
							StringAlignmentNear,
							FontStyleRegular,
							Color(255, 0, 0, 0));

			if (m_bHoverNickName)
			{
				Pen pen(m_crEditNickBGOver, 1);

				nSX = m_rtNickName.left - rtPS.left;
				nSY = m_rtNickName.top - rtPS.top;

				graph.DrawRectangle(&pen, nSX - 1, nSY - 1, m_rtNickName.Width() + 2, m_rtNickName.Height() + 2);
			}
		}

		BitBlt(dc.GetSafeHdc(), nPX, nPY, psWidth, psHeight, hdcMemory, 0, 0, SRCCOPY);

		::SelectObject(hdcMemory, hbmpOld);
		::DeleteObject(hbmpMem);
	}

	::DeleteDC(hdcMemory);
}

void CInfoAboutMeWnd::OnMouseMove(UINT nFlags, CPoint point)
{
	BOOL bHoverStatus = FALSE;
	BOOL bHoverNickName = FALSE;
	BOOL bHoverIPT = FALSE;

	if (m_rtStatus.PtInRect(point))
	{
		bHoverStatus = TRUE;
	}
	else if (m_rtNickName.PtInRect(point))
	{
		bHoverNickName = TRUE;
	}
	else if (m_rtIPTStatus.PtInRect(point))
	{
		bHoverIPT = TRUE;
	}

	if (!m_bTracking)
	{
		m_bTracking = TRUE;

		TRACKMOUSEEVENT tme;
		tme.cbSize = sizeof(TRACKMOUSEEVENT);
		tme.dwFlags = TME_HOVER | TME_LEAVE;
		tme.dwHoverTime = 1;
		tme.hwndTrack = GetSafeHwnd();
		TrackMouseEvent(&tme);
	}

	if (m_bHoverStatus != bHoverStatus)
	{
		m_bHoverStatus = bHoverStatus;
		RedrawStatus();
	}

	if (m_bHoverNickName != bHoverNickName)
	{
		m_bHoverNickName = bHoverNickName;
		RedrawNickName();
	}
	if (m_bHoverIPT != bHoverIPT)
	{
		m_bHoverIPT = bHoverIPT;
		RedrawIPTStatus();
	}

	CWnd::OnMouseMove(nFlags, point);
}

void CInfoAboutMeWnd::OnMouseHover(UINT nFlags, CPoint point)
{
	
}

void CInfoAboutMeWnd::OnMouseLeave()
{
	m_bTracking = FALSE;
	m_bHoverStatus = FALSE;
	m_bHoverIPT = FALSE;
	m_bHoverNickName = FALSE;

	RedrawStatus();
	RedrawNickName();
	RedrawIPTStatus();
}

void CInfoAboutMeWnd::RedrawStatus()
{
	CRect rtStatus = m_rtStatus;
	rtStatus.InflateRect(3, 3, 3, 3);
	RedrawWindow(&rtStatus, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}
void CInfoAboutMeWnd::RedrawIPTStatus()
{
	if (GET_APP()->IsAvailableIPT())
	{
		CRect rtStatus = m_rtIPTStatus;
		RedrawWindow(&rtStatus, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
	}

}



void CInfoAboutMeWnd::RedrawNickName()
{
	CRect rtNickName = m_rtNickName;
	rtNickName.InflateRect(4, 4, 4, 4);
	RedrawWindow(&rtNickName, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CInfoAboutMeWnd::OnLButtonDown(UINT nFlags, CPoint point)
{
	SetFocus();

	SetCapture();

	if (m_rtStatus.PtInRect(point))
	{
		m_bDownStatus = TRUE;
	}
	else if (m_rtNickName.PtInRect(point))
	{
		SetEditNickName(TRUE);
	}

	CWnd::OnLButtonDown(nFlags, point);
}

void CInfoAboutMeWnd::OnLButtonUp(UINT nFlags, CPoint point)
{
	ReleaseCapture();

	if (m_bDownStatus && m_rtStatus.PtInRect(point))
	{
		CWnd* pWndParent = GetParent();
		if (pWndParent && pWndParent->GetSafeHwnd())
		{
			pWndParent->SendMessage(WM_COMMAND, (WPARAM)GetDlgCtrlID(), (LPARAM)0);

			CRect rtStatus = m_rtStatus;
			rtStatus.InflateRect(3, 3, 3, 3);
			RedrawWindow(&rtStatus, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
		}
	}
	else if (m_rtIPTStatus.PtInRect(point) && GET_APP()->IsAvailableIPT())
	{
		CWnd* pWndParent = GetParent();
		if (pWndParent && pWndParent->GetSafeHwnd())
		{
			pWndParent->SendMessage(WM_COMMAND, (WPARAM)ID_IPT_ABOUTME, (LPARAM)0);
		}
	}
	else if (m_bDownNickName && m_rtNickName.PtInRect(point))
	{
	}

	m_bDownStatus = FALSE;
	m_bDownNickName = FALSE;

	CWnd::OnLButtonUp(nFlags, point);
}

void CInfoAboutMeWnd::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	m_rtFrame.SetRect(0, 0, cx, cy);

	int nImgWidth = 0, nImgHeight = 0;
	int nSX = 0, nSY = 0;
	int nEX = 0, nEY = 0;
	if (m_pImgLogo)
	{
		nImgWidth = m_pImgLogo->GetWidth();
		nImgHeight = m_pImgLogo->GetHeight();

		nSX = m_rtFrame.right - nImgWidth - DEF_LOGO_RIGHT_REL_POS_X;
		nSY = m_rtFrame.top + DEF_LOGO_RIGHT_REL_POS_Y;
		m_rtLogo.SetRect(nSX, nSY, nSX + nImgWidth, nSY + nImgHeight);
	}

	if (m_pImgStatusTo)
	{
		nImgWidth = m_pImgStatusTo->GetWidth();
		nImgHeight = m_pImgStatusTo->GetHeight();

		nSX = m_rtFrame.top + DEF_STATUS_REL_POS_X;
		nSY = (m_rtFrame.Height() - nImgHeight) / 2;

		m_rtStatus.SetRect(nSX, nSY, nSX + nImgWidth, nSY + nImgHeight);
	}

	int nTextHeight = (m_rtFrame.Height() - (DEF_NAME_REL_TOP_POS_Y + DEF_NICKNAME_REL_BOT_POS_Y + DEF_NAME_NICK_GAP_Y)) / 2;

	nSX = m_rtStatus.right + DEF_NAME_REL_LEFT_POS_X;
	nSY = m_rtFrame.top + DEF_NAME_REL_TOP_POS_Y;
	nEX = m_rtLogo.left - DEF_NAME_REL_RIGHT_POS_X;
	   
	CString strText;
	CRect rcBound(0, 0, 0, 0);
	CSize szBound(0, 0);
	GetClientRect(&rcBound);
	RecalcTextRectVert(this, m_strName, g_defaultFontFaceName, DEF_ME_NAME_FONT_SIZE,  FontStyleBold, rcBound, szBound);

	int nEndNameX = nSX + szBound.cx;
	m_rtName.SetRect(nSX, nSY, nEndNameX, nSY + nTextHeight);
	if (m_pImgIPTOverBG)
	{
		nImgWidth = m_pImgIPTOverBG->GetWidth();
		nImgHeight = m_pImgIPTOverBG->GetHeight();
		nEndNameX = nEndNameX + DEF_IPT_STATUS_BG_GAP_X;
		nSY = nSY - DEF_IPT_STATUS_BG_GAP_Y;
		m_rtIPTStatus.SetRect(nEndNameX, nSY, nEndNameX + nImgWidth, nSY + nImgHeight);
	}


	nEX = m_rtFrame.right - DEF_NICKNAME_REL_RIGHT_POS_X;
	nSY = m_rtName.bottom + DEF_NAME_NICK_GAP_Y;
	m_rtNickName.SetRect(nSX, nSY, nEX, nSY + nTextHeight);


	if (!m_strNickName.IsEmpty())
	{
		m_strNickNameAbbr = RecalcTextString(this, m_strNickName, g_defaultFontFaceName, DEF_NICKNAME_FONT_SIZE, FontStyleRegular, m_rtNickName);
	}

	m_rtEdit = m_rtNickName;
	m_rtEdit.DeflateRect(0, 1, 0, 0);

	if (m_editNickName.GetSafeHwnd())
		m_editNickName.MoveWindow(&m_rtEdit);
}

BOOL CInfoAboutMeWnd::OnCommand(WPARAM wParam, LPARAM lParam)
{
	UINT notificationCode = (UINT)HIWORD(wParam);

	switch (notificationCode)
	{
	case EN_KILLFOCUS:
		{
			UpdateNickName();
			return TRUE;
		}
		break;
	case EN_SETFOCUS:
		{
		}
		break;
	}

	return CWnd::OnCommand(wParam, lParam);
}

void CInfoAboutMeWnd::UpdateNickName()
{
	CString strValue = _T("");
	m_editNickName.GetWindowText(strValue);

	if (m_strNickName.Compare(strValue) != 0)
	{
		if (strValue.Find(_T('|')) >= 0)
		{
			SetEditNickName(TRUE);
			NMessageBox(this, LoadStringFromResource(IDS_STRING_MAIN_INVALIDNICKNAME));
			return;
		}

		SetEditNickName(FALSE);

		m_strNickName = strValue;
		CWnd* pWndParent = GetParent();
		if (pWndParent)
			pWndParent->SendMessage(UM_INFO_ABOUTME_EDIT_NICKNAME, (WPARAM)0, (LPARAM)m_strNickName.GetBuffer(m_strNickName.GetLength()));
	}
	else
		SetEditNickName(FALSE);
}

BOOL CInfoAboutMeWnd::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		switch (pMsg->wParam)
		{
		case VK_RETURN:
			{
				CWnd* pWndFocus = GetFocus();
				if (pWndFocus->GetDlgCtrlID() == ID_EDIT_NICKNAME)
				{
					UpdateNickName();
					return TRUE;
				}
			}
			break;
		case VK_ESCAPE:
			{
				SetEditNickName(FALSE);
			}
			break;
		}
	}

	return CWnd::PreTranslateMessage(pMsg);
}

BOOL CInfoAboutMeWnd::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	CPoint pt(0, 0);
	GetCursorPos(&pt);
	ScreenToClient(&pt);

	if (m_rtNickName.PtInRect(pt))
	{
		::SetCursor((HCURSOR)GetClassLong(m_editNickName.GetSafeHwnd(), GCL_HCURSOR));
		return TRUE;
	}

	return CWnd::OnSetCursor(pWnd, nHitTest, message);
}

void CInfoAboutMeWnd::OnDestroy()
{
	if (m_pImgBG)
	{
		delete m_pImgBG;
		m_pImgBG = NULL;
	}
	if (m_pImgLogo)
	{
		delete m_pImgLogo;
		m_pImgLogo = NULL;
	}
	if (m_pImgStatusOverBG)
	{
		delete m_pImgStatusOverBG;
		m_pImgStatusOverBG = NULL;
	}
	if (m_pImgStatusFrom)
	{
		delete m_pImgStatusFrom;
		m_pImgStatusFrom = NULL;
	}
	if (m_pImgStatusTo)
	{
		delete m_pImgStatusTo;
		m_pImgStatusTo = NULL;
	}
	if(m_pImgIPTStatus)
	{
		delete m_pImgIPTStatus;
		m_pImgIPTStatus = NULL;
	}
	if (m_pImgIPTOverBG)
	{
		delete m_pImgIPTOverBG;
		m_pImgIPTOverBG = NULL;
	}

	CWnd::OnDestroy();
}

void CInfoAboutMeWnd::RotateImageWithInterval(DWORD dwMilliseconds)
{
	m_pImgStatusDraw = m_pImgStatusTo;

	if (NULL == m_pImgStatusFrom)
		return;

	CSingleLock lock(&m_csTimerEvent);
	lock.Lock();

	RedrawWindow(&m_rtStatus, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);

	lock.Unlock();
}

void CInfoAboutMeWnd::AllocateStatusImage()
{
	CString strImageFileName = GET_APP()->GetMyPresenceImageFileName( m_gtStatus );
	SetImgStatusPath( strImageFileName );
}

void CInfoAboutMeWnd::AllocateIPTStatusImage()
{
	CString strImageFileName = GET_APP()->GetMyIPTPresenceImageFilePath( m_myIPTStatus );
	SetImgIPTStatusPath(strImageFileName);

}

